don't use the obsolete datastore.